/*
	PfExcel.cpp

	Copyright(C) 2013, ()GCRbg All rights reserved.

	1.\[XR[h`łoCi`łAύX̗LɊւ炸A
	@ȉ̏𖞂ɂāAĔzzїp܂B

	@1-1.\[XR[h`ōĔzzꍇAL쌠\A{
	@@@ё2̐ӔCKK܂߂ĂB

	@1-2.oCi`ōĔzzꍇAL쌠\A{
	@@@LӔCKAzzƂƂɒ񋟂镶/܂
	@@@̎ɕK܂߂ĂB

	2.{\tgEFA͖ۏ؂łBȐӔCŎgpĂB
 */

#include <vcl.h>
#pragma hdrstop

#include "PfExcel.h"

//---------------------------------------------------------------------------
//	class CPfExcel
//---------------------------------------------------------------------------
CPfExcel::CPfExcel() {
	Opened = false;
	ColCount = RowCount = -1;
	ObjExcel = Unassigned;
	WorkBook = Unassigned;
	UsedRange = Unassigned;
}
//---------------------------------------------------------------------------
CPfExcel::~CPfExcel() {
	Close();
}
//---------------------------------------------------------------------------
bool CPfExcel::IsInstalled() {
	bool rtn = false;
	Variant obj;
	try {
		obj = Variant::CreateObject("Excel.Application");
	}
	catch (Exception &e) {
		;//ErrMsg = e.Message;
	}
	if (obj.Type() == varDispatch)
		rtn = true;
	obj = Unassigned;
	return rtn;
}
//---------------------------------------------------------------------------
bool CPfExcel::Open(const String &fname) {
	Opened = false;
	ColCount = RowCount = -1;
	FileName = fname;
	if (FileName.IsEmpty())
		return false;
	try {
		Variant asheet;
		ObjExcel = Variant::CreateObject("Excel.Application");
		//Excel \
		ObjExcel.OlePropertySet("Visible", false); // OK
		// x⃁bZ[W\Ȃ
		ObjExcel.OlePropertySet("DisplayAlerts", false);
		// t@Cǂ
		WorkBook = ObjExcel.OlePropertyGet("WorkBooks").
					OleFunction("Open", (OleVariant)FileName);
		//workbook = workbooks.OleFunction("Open", (Variant)fname); // NG
		//workbook = workbooks.OleFunction("Open", (Variant)WideString(fname)); // OK
		//workbook = workbooks.OleFunction("Open", WideString(fname)); // OK
		//workbook = workbooks.OleFunction("Open", &WideString(fname)); // OK
		//workbook = workbooks.OleFunction("Open", (OleVariant)Edit1->Text); // OK
		//workbook = workbooks.OleFunction("Open", WideString(fname).c_bstr()); // OK

		//ANeBuV[g
		asheet = WorkBook.OlePropertyGet("ActiveSheet");
		//gpĂ͈
		UsedRange = asheet.OlePropertyGet("UsedRange");
		asheet = Unassigned;
		ColCount = UsedRange.OlePropertyGet("Columns").OlePropertyGet("Count");
		RowCount = UsedRange.OlePropertyGet("Rows").OlePropertyGet("Count");
		Opened = true;
	}
	catch (Exception &e) {
		ErrMsg = e.Message;
	}
	return Opened;
}
//---------------------------------------------------------------------------
int CPfExcel::GetColCount() {
	return ColCount;
}
//---------------------------------------------------------------------------
int CPfExcel::GetRowCount() {
	return RowCount;
}
//---------------------------------------------------------------------------
bool CPfExcel::GetRow(int irow, TStringList *list) {
	// irow  0 
	int rtn = false;
	if (!Opened)
		return rtn;
	try {
		Variant var_array =
			UsedRange.OlePropertyGet("Rows", irow+1).OlePropertyGet("Value2");
		if (var_array.ArrayDimCount() == 2) {
			int lx = var_array.ArrayLowBound(1);
			int lb = var_array.ArrayLowBound(2);
			int hb = var_array.ArrayHighBound(2);
			for (int i = lb; i <= hb; i++) {
				list->Add(var_array.GetElement(lx, i));
			}
			rtn = true;
		}
	}
	catch (Exception &e) {
		ErrMsg = e.Message;
	}
	return rtn;
}
//---------------------------------------------------------------------------
void CPfExcel::Close() {
	if (Opened) {
		try {
			if (WorkBook.Type() == varDispatch) {
				WorkBook.OleProcedure("Close");
				ObjExcel.OleProcedure("Quit");
			}
		}
		catch (Exception &e) {
			ErrMsg = e.Message;
		}
		Opened = false;
	}
	UsedRange = Unassigned;
	WorkBook = Unassigned;
	ObjExcel = Unassigned;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
